using System;

namespace FEZDominoPressureCQ
{
    public class Weather
    {
        double[] pressure;
        int num;

        public Weather(int n, double p)
        {
            pressure = new double[n];
            for (int i = 0; i < n; i++)
                pressure[i] = p;
            num = n;
        }

        public double GetWeather(double p)
        {
            double weather;
            double xy;
            double x;
            double y;
            double x2;

            for (int i = 0; i < num - 1; i++)
                pressure[i] = pressure[i+1];
            pressure[num - 1] = p;

            xy = 0;
            x  = 0;
            y  = 0;
            x2 = 0;
            for (int i = 1; i < num + 1; i++)
            {
                xy += i * pressure[i-1];
                x  += i;
                y  += pressure[i-1];
                x2 += i * i;
            }
            weather = num * (num * xy - x * y) / (num * x2 - x * x);

            return weather;
        }
    }
}